package com.yundong.third.ht.api.database.impl;

import com.yundong.base.context.Context;
import com.yundong.base.result.Result;
import com.yundong.gateway.register.annotation.YdcGateway;
import com.yundong.third.ht.api.database.ProjectAcceptance;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.Service;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;

/**
 * @Author LTC
 * @Date 2023-11-21 16:14
 */

@Slf4j
@org.springframework.stereotype.Service
@Service(version = "${dubbo.provider.version}", group = "${dubbo.provider.group}")
public class ContractSynchronization implements ProjectAcceptance {

    @YdcGateway(name = "contract-synchronization", url = "biz/third/ht/database/contractSynchronization.json")
    @Override
    public Result<StringBuilder> itemSynchronization(Context context, String appId, String version, String data) throws IllegalAccessException {


        String url1 = "http://10.136.208.159/esbmule/services/receive/DAM_FROM_PM_HT";
        System.out.println("6666666666666666666666666666666666666666666666666666666666666666666666666666");
        System.out.println(data);

        try {
            // 创建URL对象
            URL url = new URL(url1);

            // 打开连接
            HttpURLConnection connection = (HttpURLConnection) url.openConnection();

            // 设置请求方法为POST
            connection.setRequestMethod("POST");

            // 设置请求头
            connection.setRequestProperty("Content-Type", "application/json");
            connection.setRequestProperty("usercode", "YD");
            connection.setRequestProperty("password", "VE6jh6ZPrp");

            // 启用输出，并设置请求体
            connection.setDoOutput(true);
            String requestBody = data;
            try (OutputStream os = connection.getOutputStream()) {
                byte[] input = requestBody.getBytes(StandardCharsets.UTF_8);
                os.write(input, 0, input.length);
            }

            // 发起请求并获取响应
            int responseCode = connection.getResponseCode();
            System.out.println("Response Code: " + responseCode);

            // 读取响应信息
            BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
            String inputLine;
            StringBuilder response = new StringBuilder();
            while ((inputLine = in.readLine()) != null) {
                response.append(inputLine);
            }
            in.close();

            // 打印响应内容
            System.out.println("Response Body: " + response.toString());

            // 关闭连接
            connection.disconnect();
            return Result.success(response);
        } catch (Exception e) {
            e.printStackTrace();


        }

        return Result.fail("同步失败");

    }
}
