package com.yundong.third.ht.api.database.impl;

import cn.afterturn.easypoi.word.WordExportUtil;
import cn.afterturn.easypoi.word.entity.MyXWPFDocument;
import com.yundong.base.result.Result;
import com.yundong.base.service.oss.OssService;
import com.yundong.gateway.register.annotation.YdcGateway;
import com.yundong.third.ht.api.database.ContractWordServiceld;
import com.yundong.third.ht.api.database.dto.request.Contract;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.Service;
import org.apache.poi.xwpf.usermodel.XWPFDocument;
import org.springframework.beans.factory.annotation.Autowired;
import javax.validation.Valid;
import java.io.*;
import java.util.*;

@Slf4j
@org.springframework.stereotype.Service
@Service(version = "${dubbo.provider.version}", group = "${dubbo.provider.group}")

public class ContractWordServiceldImpl implements ContractWordServiceld {
    @Autowired
    private OssService ossService;
    @YdcGateway(name = "contract-word", url = "biz/third/md/database/ContractWord.json")
    @Override
    public Result<List<String>> contractWordExport(@Valid Contract request ) throws IllegalAccessException, IOException {
        Result<List<String>> result = new Result<>();
        List<String> fileUrls = new ArrayList();

        /*String str = "[{\"DESC1\":\"123\",\"DESC13\":\"浙江鑫诺检测技术有限公司\",\"DESC3\":\"123\",\"handling_dept\":\"中国能源建设集团浙江火电建设有限公司\",\"handled_by\":\"林建\",\"dept\":\"林建 2023-12-21\",\"deptLeader\":\"【林健】林健 2023-12-21 14:25:37\\n             同意\",\"depts\":\"【林健】林健 2023-12-21 14:26:01\\n同意\"},{\"DESC1\":\"4\",\"DESC13\":\"保定市方为电气制造有限公司\",\"DESC3\":\"4\",\"handling_dept\":\"林建\",\"handled_by\":\"林建\",\"dept\":\"林健 2023-12-20\",\"deptLeader\":\"【林健】林健 2023-12-21 13:46:39\\n             同意\",\"depts\":\"【林健】林健 2023-12-21 13:47:21\\n同意\\n【卢太春】卢太春 2023-12-21 13:47:56\\n同意\\n【杜文浩】杜文浩 2023-12-21 13:48:13\\n同意\\n\"}]";
        JSONArray array = JSONObject.parseArray(str);*/


        for(int i = 0; i < request.getData().size(); i++) {
            Map<String, Object> map = new HashMap<>();
            /*JSONObject item = array.getJSONObject(i);*/

            String fileUrl = "";
            map.put("DESC1", request.getData().get(i).getDESC1());
            map.put("DESC3", request.getData().get(i).getDESC3());
            map.put("DESC13", request.getData().get(i).getDESC13());
            map.put("dept", request.getData().get(i).getDept());
            map.put("deptLeader", request.getData().get(i).getDeptLeader());
            map.put("depts", request.getData().get(i).getDepts());
            map.put("handled_by", request.getData().get(i).getHandled_by());
            map.put("handling_dept", request.getData().get(i).getHandling_dept());
            map.put("leader", request.getData().get(i).getLeader());

            /*map.put("DESC1", item.getString("DESC1"));
            map.put("DESC3", item.getString("DESC3"));
            map.put("DESC13", item.getString("DESC13"));
            map.put("dept", item.getString("dept"));
            map.put("deptLeader", item.getString("deptLeader"));
            map.put("depts", item.getString("depts"));
            map.put("handled_by", item.getString("handled_by"));
            map.put("handling_dept", item.getString("handling_dept"));*/
            try {
                String fileName = "合同会签单.docx";
                InputStream resource = this.getClass().getClassLoader().getResourceAsStream("word/contract.docx");
                File catchFile = File.createTempFile(UUID.randomUUID().toString(), ".docx");
                FileOutputStream fileOutputStream = new FileOutputStream(catchFile);
                FileInputStream fileInputStream = new FileInputStream(catchFile);
                XWPFDocument word = new MyXWPFDocument(resource);
                WordExportUtil.exportWord07(word, map);
                word.write(fileOutputStream);
                /*response.setHeader("Content-disposition", "attachment;filename=\""
                        + new String(fileName.getBytes("UTF-8"), "ISO8859_1") + "\"");
                response.setContentType("application/download;charset=UTF-8");

                OutputStream outputStream = response.getOutputStream();
                word.write(outputStream);*/
                //文件上传oss

                fileUrl = ossService.uploadOssObject(request.getTenantId(), System.currentTimeMillis() + "/" + fileName, fileInputStream);
                fileUrls.add(fileUrl);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        result.setData(fileUrls);
        result.setCode(200);
        result.setMessage("成功！");
        return result;
    }

}

